;		.PASS1	ON
		.LINKLIST
		.SYMBOLS
		.PL	60

;		.EXTERN	ADDRESS1, ADDRESS2
;		.EXTERN	DATA8, DATA16

;	8051 CROSS ASSEMBLER TEST ROUTINE

		.BLKB	10

ADDRESS1:	.EQUAL	$
DATA8:  	.EQUAL	ABH
DATA16: 	.EQUAL	1234H

REG0:		.REG	10H
REG1:		.REG	11H
REG7:		.REG	17H
REG10:		.REG	10

		.CHIP	8052

;	8052 REGISTER TESTS

REG200:		.REG	T2CON		;C8H
REG201:		.REG	RCAP2L		;CAH
REG202:		.REG	RCAP2H		;CBH
REG203:		.REG	TL2		;CCH
REG204:		.REG	TH2		;CDH

;	8052 ADDRESSABLE BIT TESTS

		SETB	RL2		;C8H
		SETB	T2		;C9H
		SETB	TR2		;CAH
		SETB	EXEN2		;CBH
		SETB	TCLK		;CCH
		SETB	RCLK		;CDH
		SETB	EXF2		;CEH
		SETB	TF2		;CFH
		SETB	ET2		;ADH
		SETB	PT2		;BDH

;	8044 REGISTER TESTS

		.CHIP	8044

REG100:		.REG	STS		;C8H
REG101:		.REG	SMD		;C9H
REG102:		.REG	RCB		;CAH
REG103:		.REG	RBL		;CBH
REG104:		.REG	RBS		;CCH
REG105:		.REG	RFL		;CDH
REG106:		.REG	STAD		;CEH
REG107:		.REG	DMA		;CFH
REG108:		.REG	NSNR		;D8H
REG109:		.REG	SIUS		;D9H
REG110:		.REG	TCB		;DAH
REG111:		.REG	TBL		;DBH
REG112:		.REG	TBS		;DCH

;	8044 ADDRESSABLE BIT TESTS

		SETB	RBP		;C8H
		SETB	AM		;C9H
		SETB	OPB		;CAH
		SETB	BV		;CBH
		SETB	SI		;CCH
		SETB	RTS		;CDH
		SETB	RE		;CEH
		SETB	TBF		;CFH
		SETB	SER		;D8H
		SETB	NR0		;D9H
		SETB	NR1		;DAH
		SETB	NR2		;DBH
		SETB	SES		;DCH
		SETB	NS0		;DDH
		SETB	NS1		;DEH
		SETB	NS2		;DFH

;	80452 REGISTER TESTS

		.CHIP	80452

REG452A:	REG	ITHR   		;F6H
REG452B:	REG	OTHR   		;F7H
REG452C:	REG	SLCON  		;E8H
REG452D:	REG	SSTAT  		;E9H
REG452E:	REG	IEP   		;F8H
REG452F:	REG	MODE   		;F9H
REG452G:	REG	IWPR   		;EAH
REG452H:	REG	IRPR   		;EBH
REG452I:	REG	ORPR   		;FAH
REG452J:	REG	OWPR   		;FBH
REG452K:	REG	CBP   		;ECH
REG452L:	REG	IMIN   		;FCH
REG452M:	REG	IMOUT  		;FDH
REG452N:	REG	FIN   		;EEH
REG452O:	REG	CIN   		;EFH
REG452P:	REG	FOUT   		;FeH
REG452Q:	REG	COUT   		;FFH
REG452R:	REG	P4   		;C0H
REG452S:	REG	HSTAT   	;E6H
REG452T:	REG	HCON   		;E7H
REG452U:	REG	DCON0  		;92H
REG452V:	REG	DCON1  		;93H
REG452W:	REG	SARL0  		;A2H
REG452X:	REG	SARH0  		;A3H
REG452Y:	REG	SARL1  		;B2H
REG452Z:	REG	SARH1  		;B3H
REG452AA:	REG	DARL0   	;C2H
REG452AB:	REG	DARH0  		;C3H
REG452AC:	REG	DARL1  		;D2H
REG452AD:	REG     DARH1		;D3H	
REG452AE:	REG	BCRL0  		;E2H
REG452AF:	REG	BCRH0  		;E3H
REG452AG:	REG	BCRL1  		;F2H
REG452AH:	REG	BCRH1  		;F3H

;	80452 ADDRESSABLE BIT TESTS

		SETB	OFRS		;E8H
		SETB	IFRS		;E9H
		SETB	FRZ		;EBH
		SETB	ICOI		;ECH
		SETB	ICII		;EDH
		SETB	OFI		;EEH
		SETB	IFI		;EFH
		SETB	EFIFO		;F8H
		SETB	PDMA1		;F9H
		SETB	PDMA0		;FAH
		SETB	EDMA1		;FBH
		SETB	EDMA0		;FCH
		SETB	PFIFO		;FDH

		SETB	P
		SETB	OV
		SETB	RS0
		SETB	RS1
		SETB	F0
		SETB	AC
		SETB	CY


		.CHIP	8051

BIT0:		.REG	20H.0
BIT1:		.REG	20H.1
BIT2:		.REG	20H.2
BIT3:		.REG	20H.3
BIT4:		.REG	20H.4
BIT5:		.REG	20H.5
BIT6:		.REG	20H.6
BIT7:		.REG	20H.7
BITB0:		.REG	B.0
BITB1:		.REG	B.1
BITB2:		.REG	B.2
BITB3:		.REG	B.3
BITB4:		.REG	B.4
BITB5:		.REG	B.5
BITB6:		.REG	B.6
BITB7:		.REG	B.7

EQUBIT:		.REG	BIT7

		SETB	TF1
		SETB	TR1
		SETB	TF0
		SETB	TR0
		SETB	IE1
		SETB	IT1
		SETB	IE0
		SETB	IT0

		SETB	SM0
		SETB	SM1
		SETB	SM2
		SETB	REN
		SETB	TB8
		SETB	RB8
		SETB	TI
		SETB	RI

		SETB	EA
		SETB	ES
		SETB	ET1
		SETB	EX1
		SETB	ET0
		SETB	EX0

		SETB	PS
		SETB	PT1
		SETB	PX1
		SETB	PT0
		SETB	PX0

		SETB	P
		SETB	OV
		SETB	RS0
		SETB	RS1
		SETB	F0
		SETB	AC
		SETB	CY


ACALL:		ACALL	ADDRESS1 
		ACALL	ADDRESS2
		ACALL	DATA8


ADD:		ADD	A,R0
		ADD	A,R7
		ADD	A,REG0
		ADD	A,REG7

		ADD	A,20H
		ADD	A,REG10

		ADD	A,@R0
		ADD	A,@R1

		ADD	A,#10
		ADD	A,#DATA8


ADDC:		ADDC	A,R0
		ADDC	A,R7
		ADDC	A,REG0
		ADDC	A,REG7

		ADDC	A,20H
		ADDC	A,REG10

		ADDC	A,@R0
		ADDC	A,@R1

		ADDC	A,#10
		ADDC	A,#DATA8


AJMP:		AJMP	ADDRESS1
		AJMP	ADDRESS2
		AJMP	DATA8


ANL:		ANL	A,R0
		ANL	A,R7
		ANL	A,REG0
		ANL	A,REG7

		ANL	A,10
		ANL	A,REG10

		ANL	A,@R0
		ANL	A,@R1

		ANL	A,#10
		ANL	A,#DATA8

		ANL	20H,A
		ANL	REG10,A

		ANL	20H,#10
		ANL	REG10,#10
		ANL	20H,#DATA8
		ANL	REG10,#DATA8

		ANL	C,BIT0
		ANL	C,BIT7
		ANL	C,/BIT0
		ANL	C,/BIT7


CJNE:		CJNE	A,20H,CJNE
		CJNE	A,REG10,CJNE
		CJNE	A,REG10,CLR

		CJNE	A,#DATA8,CJNE
		CJNE	A,#DATA8,CLR

		CJNE	R0,#DATA8,CJNE
		CJNE	R7,#DATA8,CLR

		CJNE	@R0,#DATA8,CJNE
		CJNE	@R1,#DATA8,CLR


CLR:		CLR	A

		CLR	C

		CLR	BIT0
		CLR	BIT7


CPL:		CPL	A

		CPL	C

		CPL	BIT0
		CPL	BIT7


DA:		DA	A


DEC:		DEC	A

		DEC	R0
		DEC	R7
		DEC	REG0
		DEC	REG7

		DEC	20H
		DEC	REG10

		DEC	@R0
		DEC	@R1

DIV:		DIV	AB


DJNZ:		DJNZ	R0,10
		DJNZ	R0,DJNZ
		DJNZ	R7,LCALL
		DJNZ	REG0,DJNZ
		DJNZ	REG7,LCALL

		DJNZ	20H,10
		DJNZ	REG10,DJNZ
		DJNZ	REG10,LCALL


INC:		INC	A

		INC	R0
		INC	R7
		INC	REG0
		INC	REG7

		INC	20H
		INC	REG10

		INC	@R0
		INC	@R1

		INC	DPL
		INC	DPH
		INC	DPTR


JB:		JB	20H.1,10
		JB	BIT0,DJNZ
		JB	BIT7,LCALL


JBC:		JBC	20H.1,10
		JBC	BIT0,DJNZ
		JBC	BIT7,LCALL


JC:		JC	10
		JC	DJNZ
		JC	LCALL


JMP:		JMP	@A+DPTR


JNB:		JNB	20H.1,10
		JNB	BIT0,DJNZ
		JNB	BIT7,LCALL


JNC:		JNC	10
		JNC	DJNZ
		JNC	LCALL


JNZ:		JNZ	10
		JNZ	DJNZ
		JNZ	LCALL


JZ:		JZ	10
		JZ	DJNZ
		JZ	LCALL


LCALL:		LCALL	10
		LCALL	ADDRESS1
		LCALL	ADDRESS2


LJMP:		LJMP	10
		LJMP	ADDRESS1
		LJMP	ADDRESS2


MOV:		MOV	A,R0
		MOV	A,R7
		MOV	A,REG1

		MOV	A,127
		MOV	A,REG10

		MOV	A,@R0
		MOV	A,@R1

		MOV	A,#10
		MOV	A,#DATA8

		MOV	R0,A
		MOV	R7,A
		MOV	REG0,A
		MOV	REG7,A

		MOV	R0,80H
		MOV	R0,REG10

		MOV	R0,#10
		MOV	R7,#10
		MOV	R0,#DATA8
		MOV	R7,#DATA8
		MOV	REG0,#DATA8
		MOV	REG7,#DATA8

		MOV	20H,A
		MOV	REG10,A
		MOV	<ADDRESS1,A

		MOV	20H,R0
		MOV	20H,R7
		MOV	20H,REG0
		MOV	20H,REG7
		MOV	<ADDRESS1,R0
		MOV	<ADDRESS1,R7
		MOV	<ADDRESS1,REG0
		MOV	<ADDRESS1,REG7

		MOV	10H,20H
		MOV	10H,REG10
		MOV	REG10,10H
		MOV	REG10,REG10
		MOV	<ADDRESS1,REG10
		MOV	REG10,<ADDRESS1
		MOV	<ADDRESS1,<ADDRESS1

		MOV	10H,@R0
		MOV	10H,@R1
		MOV	<ADDRESS1,@R0
		MOV	<ADDRESS1,@R1

		MOV	10H,#1
		MOV	<ADDRESS1,#DATA8
		MOV	REG10,#DATA8

		MOV	@R0,A
		MOV	@R1,A

		MOV	@R0,10H
		MOV	@R1,<ADDRESS1

		MOV	@R0,#10H
		MOV	@R1,#10H
		MOV	@R0,#DATA8

		MOV	C,BIT0
		MOV	C,BIT7
		MOV	C,P1.0
		MOV	C,A.7

		MOV	BIT0,C
		MOV	BIT7,C
		MOV	P1.0,C
		MOV	A.7,C

		MOV	A,DPL
		MOV	A,DPH
		MOV	DPL,A
		MOV	DPH,A

		MOV	DPTR,#1234H
		MOV	DPTR,#DATA16
		MOV	DPTR,#ADDRESS1
		MOV	DPTR,#ADDRESS2

MOVC:		MOVC	A,@A+DPTR
		MOVC	A,@A+PC

MOVX:		MOVX	A,@R0
		MOVX	A,@R1

		MOVX	A,@DPTR

		MOVX	@R0,A
		MOVX	@R1,A

		MOVX	@DPTR,A

MUL:		MUL	AB


NOP:		NOP


ORL:		ORL	A,R0
		ORL	A,R7
		ORL	A,REG0
		ORL	A,REG7

		ORL	A,20H
		ORL	A,REG10

		ORL	A,@R0
		ORL	A,@R1

		ORL	A,#10
		ORL	A,#DATA8

		ORL	20H,A
		ORL	REG10,A

		ORL	10,#10
		ORL	REG10,#DATA8

		ORL	C,20H.0
		ORL	C,BIT0
		ORL	C,BIT7

		ORL	C,/20H.1
		ORL	C,/BIT0
		ORL	C,/BIT7


POP:		POP	20H
		POP	REG10
		POP	A
		POP	B


PUSH:		PUSH	20H
		PUSH	REG10
		PUSH	A
		PUSH	B


RET:		RET
		RET			;COMMENT TEST


RETI:		RETI
		RETI			;COMMENT TEST


RL:		RL	A


RLC:		RLC	A


RR:		RR	A


RRC:		RRC	A


SETB:		SETB	C

		SETB	20H.1
		SETB	BIT0
		SETB	BIT7



SJMP:		SJMP	SETB
		SJMP	SUBB
		SJMP	10


SUBB:		SUBB	A,R0
		SUBB	A,R7
		SUBB	A,REG0
		SUBB	A,REG7

		SUBB	A,20H
		SUBB	A,REG10

		SUBB	A,@R0
		SUBB	A,@R1

		SUBB	A,#10
		SUBB	A,#DATA8


SWAP:		SWAP	A


XCH:		XCH	A,R0
		XCH	A,R7
		XCH	A,REG0
		XCH	A,REG7

		XCH	A,20H
		XCH	A,REG10

		XCH	A,@R0
		XCH	A,@R1


XCHD:		XCHD	A,@R0
		XCHD	A,@R1


XRL:		XRL	A,R0
		XRL	A,R7
		XRL	A,REG0
		XRL	A,REG7

		XRL	A,20H
		XRL	A,REG10

		XRL	A,@R0
		XRL	A,@R1

		XRL	A,#10
		XRL	A,#DATA8

		XRL	20H,A
		XRL	REG10,A

		XRL	20H,#10
		XRL	REG10,#DATA8


ADDRESS2:	.EQUAL	$

		list on
		.END
